CMSIS-DSP: Vector Clarke Transform

| CMSIS-DSP Version 1.5.2 CMSIS DSP Software Library

- Main Page
- Usage and Description
- Reference

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Functions
Vector Clarke Transform
Controller Functions

## Functions
CMSIS_INLINE __STATIC_INLINE void | arm_clarke_f32 (float32_t Ia, float32_t Ib, float32_t *pIalpha, float32_t *pIbeta)
| Floating-point Clarke transform. More...
CMSIS_INLINE __STATIC_INLINE void | arm_clarke_q31 (q31_t Ia, q31_t Ib, q31_t *pIalpha, q31_t *pIbeta)
| Clarke transform for Q31 version. More...

## Description

Forward Clarke transform converts the instantaneous stator phases into a two-coordinate time invariant vector. Generally the Clarke transform uses three-phase currents `Ia, Ib and Ic` to calculate currents in the two-phase orthogonal stator axis `Ialpha` and `Ibeta`. When `Ialpha` is superposed with `Ia` as shown in the figure below

Stator current space vector and its components in (a,b).

and `Ia + Ib + Ic = 0`, in this condition `Ialpha` and `Ibeta` can be calculated using only `Ia` and `Ib`.

The function operates on a single sample of data and each call to the function returns the processed output. The library provides separate functions for Q31 and floating-point data types.

Algorithm
  where `Ia` and `Ib` are the instantaneous stator phases and `pIalpha` and `pIbeta` are the two coordinates of time invariant vector.

Fixed-Point Behavior
  Care must be taken when using the Q31 version of the Clarke transform. In particular, the overflow and saturation behavior of the accumulator used must be considered. Refer to the function specific documentation below for usage guidelines.

## Function Documentation

CMSIS_INLINE __STATIC_INLINE void arm_clarke_f32 | ( | float32_t | Ia,
|  | float32_t | Ib,
|  | float32_t * | pIalpha,
|  | float32_t * | pIbeta
| ) |  |

Parameters

  [in] | Ia | input three-phase coordinate `a`
  [in] | Ib | input three-phase coordinate `b`
  [out] | pIalpha | points to output two-phase orthogonal vector axis alpha
  [out] | pIbeta | points to output two-phase orthogonal vector axis beta

CMSIS_INLINE __STATIC_INLINE void arm_clarke_q31 | ( | q31_t | Ia,
|  | q31_t | Ib,
|  | q31_t * | pIalpha,
|  | q31_t * | pIbeta
| ) |  |

Parameters

  [in] | Ia | input three-phase coordinate `a`
  [in] | Ib | input three-phase coordinate `b`
  [out] | pIalpha | points to output two-phase orthogonal vector axis alpha
  [out] | pIbeta | points to output two-phase orthogonal vector axis beta

Scaling and Overflow Behavior:

  The function is implemented using an internal 32-bit accumulator. The accumulator maintains 1.31 format by truncating lower 31 bits of the intermediate multiplication in 2.62 format. There is saturation on the addition, hence there is no risk of overflow.

References __QADD().